<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\Order;
use LogicException;

/**
 * Class OrderE2V
 * @package Plugin\Logiless\E2V
 */
class OrderE2V extends AbstractE2V
{
    /**
     * @param $data
     *
     * @return array
     */
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $views = array();

        foreach ($data as $order) {
            if (!$order instanceof Order) {
                throw new LogicException();
            }

            $views[] = array(
                'id' => $order->getId(),
                'message' => $order->getMessage(),
                'name01' => $order->getName01(),
                'name02' => $order->getName02(),
                'kana01' => $order->getKana01(),
                'kana02' => $order->getKana02(),
                'company_name' => $order->getCompanyName(),
                'email' => $order->getEmail(),
                'tel01' => $order->getTel01(),
                'tel02' => $order->getTel02(),
                'tel03' => $order->getTel03(),
                'fax01' => $order->getFax01(),
                'fax02' => $order->getFax02(),
                'fax03' => $order->getFax03(),
                'zipcode' => $order->getZipcode(),
                'pref' => $order->getPref() ?
                    $order->getPref()->getName() : null,
                'addr01' => $order->getAddr01(),
                'addr02' => $order->getAddr02(),
                'subtotal' => $order->getSubtotal(),
                'discount' => $order->getDiscount(),
                'delivery_fee_total' => $order->getDeliveryFeeTotal(),
                'charge' => $order->getCharge(),
                'tax' => $order->getTax(),
                'total' => $order->getTotal(),
                'payment_total' => $order->getPaymentTotal(),
                'payment_method' => $order->getPaymentMethod(),
                'create_date' => $order->getCreateDate() ?
                    $order->getCreateDate()->format('Y-m-d H:i:s') : null,
                'update_date' => $order->getUpdateDate() ?
                    $order->getUpdateDate()->format('Y-m-d H:i:s') : null,
                'order_date' => $order->getOrderDate() ?
                    $order->getOrderDate()->format('Y-m-d H:i:s') : null,
                'commit_date' => $order->getCommitDate() ?
                    $order->getCommitDate()->format('Y-m-d H:i:s') : null,
                'payment_date' => $order->getPaymentDate() ?
                    $order->getPaymentDate()->format('Y-m-d H:i:s') : null,
                'order_status' => $order->getOrderStatus() ?
                    $order->getOrderStatus()->getName() : null,
                'custom_order_status' => $order->getCustomerOrderStatus() ?
                    $order->getCustomerOrderStatus()->getName() : null,
                'shippings' => ShippingE2V::convert($order->getShippings()->toArray()),
                'customer' => $order->getCustomer() ?
                    CustomerE2V::convert($order->getCustomer()) : null,
            );
        }

        return $views;
    }
}