<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\ProductClass;
use LogicException;

/**
 * Class ProductClassE2V
 * @package Plugin\Logiless\E2V
 */
class ProductClassE2V extends AbstractE2V
{
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $productClass) {
            if (!$productClass instanceof ProductClass) {
                throw new LogicException();
            }

            $view[] = array(
                'id' => $productClass->getId(),
                'code' => $productClass->getCode(),
                'stock' => $productClass->getStock(),
                'stock_unlimited' => $productClass->getStockUnlimited(),
                'class_category_1' => $productClass->getClassCategory1() ?
                    ClassCategoryE2V::convert($productClass->getClassCategory1()) : null,
                'class_category_2' => $productClass->getClassCategory2() ?
                    ClassCategoryE2V::convert($productClass->getClassCategory2()) : null,
                'product' => $productClass->getProduct() ?
                    ProductE2V::convert($productClass->getProduct()) : null,
            );
        }

        return $view;
    }
}