<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\ShipmentItem;
use LogicException;

/**
 * Class ShipmentItemE2V
 * @package Plugin\Logiless\E2V
 */
class ShipmentItemE2V extends AbstractE2V
{
    /**
     * @param $data
     *
     * @return array
     */
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $shipmentItem) {
            if (!$shipmentItem instanceof ShipmentItem) {
                throw new LogicException();
            }

            $view[] = array(
                'id' => $shipmentItem->getId(),
                'product_name' => $shipmentItem->getProductName(),
                'product_code' => $shipmentItem->getProductCode(),
                'class_name1' => $shipmentItem->getClassName1(),
                'class_name2' => $shipmentItem->getClassName2(),
                'class_category_name1' => $shipmentItem->getClassCategoryName1(),
                'class_category_name2' => $shipmentItem->getClassCategoryName2(),
                'price' => $shipmentItem->getPrice(),
                'price_inc_tax' => $shipmentItem->getPriceIncTax(),
                'quantity' => $shipmentItem->getQuantity(),
                'product_class' => ProductClassE2V::convert($shipmentItem->getProductClass())
            );
        }

        return $view;
    }
}