<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\E2V;

use Eccube\Entity\Shipping;
use LogicException;

/**
 * Class ShippingE2V
 * @package Plugin\Logiless\E2V
 */
class ShippingE2V extends AbstractE2V
{
    /**
     * @param $data
     *
     * @return array
     */
    public static function convert($data)
    {
        $data = is_array($data) ? $data : array($data);

        $view = array();

        foreach ($data as $shipping) {
            if (!$shipping instanceof Shipping) {
                throw new LogicException();
            }

            $view[] = array(
                'id' => $shipping->getId(),
                'name01' => $shipping->getName01(),
                'name02' => $shipping->getName02(),
                'kana01' => $shipping->getKana01(),
                'kana02' => $shipping->getKana02(),
                'company_name' => $shipping->getCompanyName(),
                'tel01' => $shipping->getTel01(),
                'tel02' => $shipping->getTel02(),
                'tel03' => $shipping->getTel03(),
                'fax01' => $shipping->getFax01(),
                'fax02' => $shipping->getFax02(),
                'fax03' => $shipping->getFax03(),
                'zip01' => $shipping->getZip01(),
                'zip02' => $shipping->getZip02(),
                'zipcode' => $shipping->getZipcode(),
                'pref' => $shipping->getPref() ?
                    $shipping->getPref()->getName() : null,
                'addr01' => $shipping->getAddr01(),
                'addr02' => $shipping->getAddr02(),
                'delivery_name' => $shipping->getShippingDeliveryName(),
                'delivery_time' => $shipping->getShippingDeliveryTime(),
                'delivery_date' => $shipping->getShippingDeliveryDate() ?
                    $shipping->getShippingDeliveryDate()->format('Y-m-d H:i:s') : null,
                'delivery_fee' => $shipping->getDeliveryFee() ?
                    $shipping->getDeliveryFee()->getFee() : null,
                'commit_date' => $shipping->getShippingCommitDate() ?
                    $shipping->getShippingCommitDate()->format('Y-m-d H:i:s') : null,
                'create_date' => $shipping->getCreateDate() ?
                    $shipping->getCreateDate()->format('Y-m-d H:i:s') : null,
                'update_date' => $shipping->getUpdateDate() ?
                    $shipping->getUpdateDate()->format('Y-m-d H:i:s') : null,
                'shipment_items' => ShipmentItemE2V::convert($shipping->getShipmentItems()->toArray()),
            );
        }

        return $view;
    }
}