<?php
/*
 * (c) Logiless Inc.
 */

namespace Plugin\Logiless\ServiceProvider;

use Eccube\Common\Constant;
use Silex\Application as BaseApplication;
use Silex\ServiceProviderInterface;

/**
 * Class LogilessServiceProvider
 * @package Plugin\Logiless\ServiceProvider
 */
class LogilessServiceProvider implements ServiceProviderInterface
{
    public function register(BaseApplication $app)
    {
        // フロント画面定義
        $front = $app['controllers_factory'];

        // 強制SSL
        if ($app['config']['force_ssl'] == Constant::ENABLED) {
            $front->requireHttps();
        }

        $front
            ->match('/plugin/logiless/orders.json', 'Plugin\Logiless\Controller\OrdersController::index')
            ->bind('plugin_logiless_orders');

        $front
            ->match('/plugin/logiless/order.json', 'Plugin\Logiless\Controller\OrderController::index')
            ->bind('plugin_logiless_order');

        $front
            ->match('/plugin/logiless/product_classes.json', 'Plugin\Logiless\Controller\ProductClassesController::index')
            ->bind('plugin_logiless_products');

        $front
            ->match('/plugin/logiless/product_classes.json', 'Plugin\Logiless\Controller\ProductClassesController::index')
            ->bind('plugin_logiless_product');

        $app->mount('', $front);
    }

    public function boot(BaseApplication $app)
    {
    }
}
